from sys import *
from pydasm import *
from disassOpcodes import *
from atlasutils.smartprint import *


"""while offset < len(buffer):
   i = get_instruction(buffer[offset:], MODE_32)
   loc = base+offset
   print("%x: %s"%(loc, get_instruction_string(i, FORMAT_ATT, loc)))
   if not i:
     break
   offset += i.length
   

>>> o=get_instruction('\x00\x00', MODE_32)
>>> vars(o)
{'__module__': '__main__', 'op1': <class __main__.Operand at 0xb7d9c47c>, 'op2': <class __main__.Operand at 0xb7d9c4ac>, 'op3': <class __main__.Operand at 0xb7d9c4dc>, 'dispbytes': 0L, 'sectionbytes': 0L, 'extindex': 0L, 'immbytes': 0L, 'fpuindex': 0L, 'ptr': <class __main__.Inst at 0xb7d9c50c>, 'sib': 0L, 'length': 2L, 'opcode': 0L, 'mode': 0L, 'flags': 0L, 'modrm': 0L, 'type': 4L, '__doc__': None}

>>> vars(o.ptr)
{'mnemonic': 'add', '__module__': '__main__', 'flags1': 33824768L, 'flags3': 0L, 'flags2': 33898496L, 'modrm': 1L, 'type': 4L, '__doc__': None}

>>> vars(o.op1)
{'basereg': 0L, '__module__': '__main__', 'scale': 0L, 'dispoffset': 0L, 'dispbytes': 0L, 'sectionbytes': 0L, 'immbytes': 0L, 'displacement': 0L, 'immediate': 0L, 'reg': 8L, 'indexreg': 8L, 'flags': 33824768L, 'section': 0L, 'immoffset': 0L, 'type': 1L, '__doc__': None}

>>> vars(o.op2)
{'basereg': 8L, '__module__': '__main__', 'scale': 0L, 'dispoffset': 0L, 'dispbytes': 0L, 'sectionbytes': 0L, 'immbytes': 0L, 'displacement': 0L, 'immediate': 0L, 'reg': 0L, 'indexreg': 8L, 'flags': 33898496L, 'section': 0L, 'immoffset': 0L, 'type': 2L, '__doc__': None}


   
       def __init__(self, bytes):
        self.opobj = None
        self.op1type = None
        self.op2type = None
        self.op3type = None
        self.address = 0
        self.linksto = []           # list of subs, sections, program headers, relocs these operands point to
        self.linksfrom = []         # list of subs which point to me.  Must implement "getReferenceInformation(self, address)"
        self.stringdesc = [ "" ]    # list of string information about this line of ASM.  By actually connecting to the subs and callers, this section will likely only be "sub+0x20" and such
        init(bytes)
        
"""
formatops = [ FORMAT_ATT, FORMAT_INTEL ]

class disassOpcode(opcode):
    ### IMPLEMENTATIONS MUST OVERRIDE THESE SUBS:
    def init(self, bytes, address, mode=32):
        if (mode == 32):  pymode = MODE_32
        
        self.opobj = get_instruction(bytes, pymode)
        #print >>stderr,(get_instruction_string(self.opobj, FORMAT_ATT, self.address))
        
    def isMEMREF(self):     # Is it interesting for Memory References?   (target or destination a Memory References)
        return (get_register_type(self.opobj.op1) == OPERAND_TYPE_MEMORY or get_register_type(self.opobj.op2) == OPERAND_TYPE_MEMORY or get_register_type(self.opobj.op3) == OPERAND_TYPE_MEMORY)
    def isJMP(self):        # Is the opcode a JMP of some sort?   (self.opcode[0] == "j")???
        #print get_mnemonic_string(self.opobj, FORMAT_ATT)[0]
        return get_mnemonic_string(self.opobj, FORMAT_ATT)[0] == 'j'
    def isCALL(self):       # Is the opcode a Call of some sort?   (self.opcode[:2] == "ca")??
        #print get_mnemonic_string(self.opobj, FORMAT_ATT)[:2]
        return get_mnemonic_string(self.opobj, FORMAT_ATT)[:2] == 'ca'
    
    def getOp1Type(self):
        if (self.opobj.op1.type == OPERAND_TYPE_NONE): return OPERANDTYPE_NONE
        if (self.opobj.op1.type == OPERAND_TYPE_MEMORY): return OPERANDTYPE_MEMREF
        if (self.opobj.op1.type == OPERAND_TYPE_REGISTER): return OPERANDTYPE_REGISTER
        if (self.opobj.op1.type == OPERAND_TYPE_IMMEDIATE): return OPERANDTYPE_IMMEDIATE
        return None
    def getOp2Type(self):
        if (self.opobj.op2.type == OPERAND_TYPE_NONE): return OPERANDTYPE_NONE
        if (self.opobj.op2.type == OPERAND_TYPE_MEMORY): return OPERANDTYPE_MEMREF
        if (self.opobj.op2.type == OPERAND_TYPE_REGISTER): return OPERANDTYPE_REGISTER
        if (self.opobj.op2.type == OPERAND_TYPE_IMMEDIATE): return OPERANDTYPE_IMMEDIATE
        
    def getOp3Type(self):
        if (self.opobj.op3.type == OPERAND_TYPE_NONE): return OPERANDTYPE_NONE
        if (self.opobj.op3.type == OPERAND_TYPE_MEMORY): return OPERANDTYPE_MEMREF
        if (self.opobj.op3.type == OPERAND_TYPE_REGISTER): return OPERANDTYPE_REGISTER
        if (self.opobj.op3.type == OPERAND_TYPE_IMMEDIATE): return OPERANDTYPE_IMMEDIATE
    
    def getLocalVar(self):
        # Search for Op1 of type OPERAND_REGISTER and look for accesses relative to %ebp
        # The idea is that no local variable is worth mentioning if it's not read from
        if (self.opobj.op2.basereg == REGISTER_EBP):        ### FIXME BROKEN
            var = self.opobj.op2.displacement
            return var
        elif (self.opobj.op1.basereg == REGISTER_EBP):
            var = self.opobj.op1.displacement
            return var
        elif (self.opobj.op3.basereg == REGISTER_EBP):
            var = self.opobj.op3.displacement
            return var
        
        return None
    
    """
fffffff4(%ebp)
{'basereg': 5L, '__module__': 'disassPyDasm', 'scale': 0L, 'dispoffset': 2L, 'dispbytes': 1L, 'sectionbytes': 0L, 'immbytes': 0L, 'displacement': -12L, 'immediate': 0L, 'reg': 8L, 'indexreg': 8L, 'flags': 117710848L, 'section': 0L, 'immoffset': 0L, 'type': 1L, '__doc__': None}
>>> vars(self.op2)

%ebx
{'basereg': 8L, '__module__': 'disassPyDasm', 'scale': 0L, 'dispoffset': 0L, 'dispbytes': 0L, 'sectionbytes': 0L, 'immbytes': 0L, 'displacement': 0L, 'immediate': 0L, 'reg': 3L, 'indexreg': 8L, 'flags': 117784576L, 'section': 0L, 'immoffset': 0L, 'type': 2L, '__doc__': None}

The first one is FFFF4(%ebp) and the second one is %ebx.
Apparently the "basereg" is used for dereffed registers and "reg" is used for direct register access
How does RegisterType work?
    """
    
    def getOpAddress(self, op):
        """ getOpAddress() is Operand-agnostic, and called by getOp1Address, getOp2Address, and getOp3Address.
        It returns an array of the following format.  If not all fields are necessary, the array is smaller:  [address, specialdescriptor(*$), segment/section]
        """
        if (op.type == OPERAND_TYPE_IMMEDIATE):
            AM = op.flags & 0x00ff0000                              # MASK_AM per libdasm.h
            if (AM == 0x00070000):                                  # AM_J
                return [op.immediate + self.address + self.opobj.length]

            elif (AM == 0x00060000 or AM == 0x00200000):            # AM_I or AM_I
                return [op.immediate, "$"]
            
            elif (AM == 0x00010000):                                # AM_A
                return [op.displacement, "", op.section]
            
        elif (op.type == OPERAND_TYPE_MEMORY):                    ### Offset from register
            if (op.displacement > 0):
                if (op.flags & 0x0000f000 == 0x00001000):           # Execute
                    return [op.displacement, "*"]
                else:
                    return [op.displacement]
        
        ###elif (oper.type == OPERAND_TYPE_REGISTER):### WHO THE FREAK CARES?!
        return None
    
    def getOp1Address(self):
        #return int(get_operand_string(self.opobj, 0, self.formatops[self.asmstyle], self.address),16)
        return self.getOpAddress(self.opobj.op1)
    
    def getOp2Address(self):
        #return int(get_operand_string(self.opobj, 1, self.formatops[self.asmstyle], self.address),16)
        return self.getOpAddress(self.opobj.op2)
    
    def getOp3Address(self):
        #return int(get_operand_string(self.opobj, 2, self.formatops[self.asmstyle], self.address),16)
        return self.getOpAddress(self.opobj.op3)
        
    
    
    def __str__(self):
        output = ""
        if (self.refsfrom or self.callsfrom or self.jmpsfrom):
            output += "\n"
        if self.refsfrom:
            for shooter in self.refsfrom:               ### shooter is a tuple (offset, sub) where offset is the difference from the base address of the owner sub
                name = shooter[1].name
                if shooter[1].contains(self.address):
                    name = "(local)"
                output += "\tReferenced by: %s   at %x\n"%(name,shooter[0])  # was using getQuickyRef, but why?
        if self.callsfrom:
            for shooter in self.callsfrom:
                name = shooter[1].name
                if shooter[1].contains(self.address):
                    name = "(local)"
                output += "\tCalled from: %s   at %x\n"%(name,shooter[0])
        if self.jmpsfrom:
            for shooter in self.jmpsfrom:
                name = shooter[1].name
                if shooter[1].contains(self.address):
                    name = "(local)"
                output += "\tJMPed from: %s   at %x\n"%(name,shooter[0])
        
        #output += "%8x:\t%-30s%-40s\t"%(hexText(self.opobj.bytes),self.address, get_instruction_string(self.opobj, self.formatops[self.asmstyle], self.address))
        output += "%8x:\t%-50s\t"%(self.address, get_instruction_string(self.opobj, formatops[self.asmstyle], self.address))
        
        div = "  "
        if (self.stringdesc):
            output += ";  " + "  ".join(self.stringdesc)
        else:
            div = "; "
            
        if self.linksto:
            output += div
            for target in self.linksto:             # tuple (address, owningsub)
                output += "%s\t "%(self.opobj.ptr.mnemonic)
                tgt = target[1][0]
                if (not tgt.contains(self.address)):
                    output += tgt.name
                else:
                    output += "(local)"
                output += "  :%+-x:    "%(self.opobj.op1.displacement+self.opobj.op1.immediate)
        #output += "\n   %s"%(vars(self.opobj.op1))
        #output += "\n   %s"%(vars(self.opobj.op2))
        #output += "\n   %s"%(vars(self.opobj.op3))
            
        return output
        
        
    def getTargetDistance(self):
        return self.opobj.op1.displacement+self.opobj.op1.immediate
    
    def getOpName(self):
        return self.opobj.ptr.mnemonic
    
    def __len__(self):
        return int(self.opobj.length)

"""
    Create a new opcode object
>>> get_instruction(buffer[offset:], MODE_32)

    Get String Repr of an opcode object
>>> get_instruction_string(i, FORMAT_ATT, loc)

    Get string of opcode type
>>> get_mnemonic_string(o, 0)
'add'
"""